=== debian/changelog ===
log4cxx (0.13.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Frost <tobi@debian.org>  Sun, 12 Jun 2022 09:54:42 +0200

log4cxx (0.13.0-1) experimental; urgency=medium

  * New upstream release, fixing an old threading/signal bug (Closes: #548074).
  * Upload to experimental for the library transition.
  * Adapt packaing for SONAME bump to 13.
  * Removing all patches, as they have been applied upstream.
  * Update d/copyright years.
  * Update patch required for autopkgtest.
  * Disable inetaddresstestcase -- needs network.
  * Update lintian overrides.
  * Disable flaky tests during build.

 -- Tobias Frost <tobi@debian.org>  Wed, 25 May 2022 12:37:54 +0200
